// sNZVF[_[̓
struct PS_INPUT
{
	float2 TexCoords0      : TEXCOORD0 ;	// eNX`W
	float3 VPosition       : TEXCOORD1 ;    // W( r[ )
	float3 VTan            : TEXCOORD2 ;    // ڐ( r[ )
	float3 VBin            : TEXCOORD3 ;    // ]@( r[ )
	float3 VNormal         : TEXCOORD4 ;    // @( r[ )
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0           : SV_TARGET0 ;	// F
} ;



// }eAp[^
struct DX_D3D11_CONST_MATERIAL
{
	float4		Diffuse ;				// fBt[YJ[
	float4		Specular ;				// XyLJ[
	float4		Ambient_Emissive ;		// }eAG~bVuJ[ + }eAArGgJ[ * O[oArGgJ[

	float		Power ;					// XyL̋
	float		TypeParam0 ;			// }eA^Cvp[^0
	float		TypeParam1 ;			// }eA^Cvp[^1
	float		TypeParam2 ;			// }eA^Cvp[^2
} ;

// tHOp[^
struct DX_D3D11_VS_CONST_FOG
{
	float		LinearAdd ;				// tHOpp[^ end / ( end - start )
	float		LinearDiv ;				// tHOpp[^ -1  / ( end - start )
	float		Density ;				// tHOpp[^ density
	float		E ;						// tHOpp[^ Rΐ̒

	float4		Color ;					// J[
} ;

// Cgp[^
struct DX_D3D11_CONST_LIGHT
{
	int			Type ;					// Cg^Cv( DX_LIGHTTYPE_POINT Ȃ )
	int3		Padding1 ;				// pfBOP

	float3		Position ;				// W( r[ )
	float		RangePow2 ;				// L̂Q

	float3		Direction ;				// ( r[ )
	float		FallOff ;				// X|bgCgpFallOff

	float3		Diffuse ;				// fBt[YJ[
	float		SpotParam0 ;			// X|bgCgpp[^O( cos( Phi / 2.0f ) )

	float3		Specular ;				// XyLJ[
	float		SpotParam1 ;			// X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )

	float4		Ambient ;				// ArGgJ[ƃ}eÃArGgJ[Z

	float		Attenuation0 ;			// ɂ錸pp[^O
	float		Attenuation1 ;			// ɂ錸pp[^P
	float		Attenuation2 ;			// ɂ錸pp[^Q
	float		Padding2 ;				// pfBOQ
} ;

// sNZVF[_[E_VF[_[ʃp[^
struct DX_D3D11_CONST_BUFFER_COMMON
{
	DX_D3D11_CONST_LIGHT		Light[ 6 ] ;			// Cgp[^
	DX_D3D11_CONST_MATERIAL		Material ;				// }eAp[^
	DX_D3D11_VS_CONST_FOG		Fog ;					// tHOp[^
} ;

// 萔obt@sNZVF[_[{p[^
struct DX_D3D11_PS_CONST_BUFFER_BASE
{
	float4		FactorColor ;			// At@l

	float		MulAlphaColor ;			// J[ɃAt@lZ邩ǂ( 0.0f:ZȂ  1.0f:Z )
	float		AlphaTestRef ;			// At@eXgŎgprl
	float2		Padding1 ;

	int			AlphaTestCmpMode ;		// At@eXgr[h( DX_CMP_NEVER Ȃ )
	int3		Padding2 ;

	float4		IgnoreTextureColor ;	// eNX`J[pJ[
} ;

// _VF[_[EsNZVF[_[ʃp[^
cbuffer cbD3D11_CONST_BUFFER_COMMON					: register( b0 )
{
	DX_D3D11_CONST_BUFFER_COMMON		g_Common ;
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_PS_BASE				: register( b1 )
{
	DX_D3D11_PS_CONST_BUFFER_BASE		g_Base ;
} ;


SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`
SamplerState g_NormalMapSampler             : register( s1 ) ;		// @}bveNX`
Texture2D    g_NormalMapTexture             : register( t1 ) ;		// @}bveNX`


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float3 V_to_Eye ;
	float3 Normal ;
	float3 VNrm ;
	float3 VTan ;
	float3 VBin ;
	float3 TotalDiffuse ;
	float3 TotalSpecular ;
	float3 SpecularColor ;
	float3 TempF3 ;
	float Temp ;
	float3 lLightTemp ;
	float3 lLightDir ;
	float DiffuseAngleGen ;

	// ڐE]@E@𐳋K
	VNrm = normalize( PSInput.VNormal );
	VTan = normalize( PSInput.VTan );
	VBin = normalize( PSInput.VBin );

	// _W王_ւ̃xNgڒԂɓe㐳Kĕۑ
	TempF3.x = dot( VTan, -PSInput.VPosition.xyz ) ;
	TempF3.y = dot( VBin, -PSInput.VPosition.xyz ) ;
	TempF3.z = dot( VNrm, -PSInput.VPosition.xyz ) ;
	V_to_Eye = normalize( TempF3 ) ;

	// @ 0`1 ̒l -1.0`1.0 ɕϊ
	Normal = ( g_NormalMapTexture.Sample( g_NormalMapSampler, PSInput.TexCoords0.xy ).rgb - float3( 0.5f, 0.5f, 0.5f ) ) * 2.0f ;

	// fBt[YJ[ƃXyLJ[̒~ϒl
	TotalDiffuse  = float3( 0.0f, 0.0f, 0.0f ) ;
	TotalSpecular = float3( 0.0f, 0.0f, 0.0f ) ;




	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// CgxNǧvZ
	TempF3 = g_Common.Light[ 0 ].Direction ;

	// Cg̃xNgڒnԂɕϊ
	lLightDir.x = dot( VTan, TempF3 ) ;
	lLightDir.y = dot( VBin, TempF3 ) ;
	lLightDir.z = dot( VNrm, TempF3 ) ;

	// fBt[YFvZ

	// DiffuseAngleGen = fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * }eÃfBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
	TotalDiffuse += g_Common.Light[ 0 ].Diffuse * g_Common.Material.Diffuse.xyz * DiffuseAngleGen + g_Common.Light[ 0 ].Ambient.xyz ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), g_Common.Material.Power )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), g_Common.Material.Power ) ;

	// XyLJ[~ϒl += Temp * Cg̃XyLJ[
	TotalSpecular += Temp * g_Common.Light[ 0 ].Specular ;

	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( I )




	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// TotalDiffuse = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
	TotalDiffuse += g_Common.Material.Ambient_Emissive.xyz ;

	// SpecularColor = Cg̃XyLJ[~ϒl * }eÃXyLJ[
	SpecularColor = TotalSpecular * g_Common.Material.Specular.xyz ;

	// o̓J[ = TotalDiffuse * eNX`J[ + SpecularColor
	TextureDiffuseColor = g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0 ) ;
	PSOutput.Color0.rgb = TextureDiffuseColor.rgb * TotalDiffuse + SpecularColor ;

	// At@l = eNX`At@ * }eÃfBt[YAt@ * sx
	PSOutput.Color0.a = TextureDiffuseColor.a * g_Common.Material.Diffuse.a * g_Base.FactorColor.a ;

	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return PSOutput ;
}


